<?php

  /**
   * Automatic Image Upload with Thumbnails - uploadimg_gallery.php
   * 
   * @author : Koos
   * @gallery version 1.2.2
   * @gallery release date : 2013-05-05
   */
   
   
   
  /*****************************************************
  ** Gallery configuration
  *****************************************************/

// ** Gallery settings
$gimages_per_page = "20"; // number of images displayed per page in the gallery
$gimages_per_row = "4";

$snip_user = "8"; // Shortens string - default = 8
$snip_filename = "20";  // Shortens string - default = 20


  /*****************************************************
  ** Additional language definitions
  *****************************************************/
  
$lang_uploadimg_gallery = array(

'Gallery'		        =>	'Gallery',
'All users'				=>	'All users',
'User'				    =>	'User',
'Uploaded'				=>	'Uploaded',
'Filesize'				=>	'Filesize',
);



include "uploadimg_config.php";


define('PUN_ROOT', './');


require PUN_ROOT.'include/common.php';

// Load the uploadimg.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/uploadimg.php';


// Detect two byte character sets
$multibyte = (isset($lang_common['lang_multibyte']) && $lang_common['lang_multibyte']) ? true : false;



$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_uploadimg_gallery['Gallery'];



require PUN_ROOT.'header.php';

$getid = $_GET['id'];
$gfile_prefix = $getid ."_";
if (!empty($getid )) {
$addthis = "id=$getid";
        $result_view = $db->query('SELECT id, username FROM '.$db->prefix.'users WHERE id = '.intval($getid));
        $krydit = $db->fetch_assoc($result_view);
        $gdisplayname = $krydit ['username'];
        
                if (empty($gdisplayname)){
        $gdisplayname = $lang_uploadimg['Deleted user'];
        }
}


			if ($pun_user['is_guest']) {
		//message($lang_common['Not logged in']);
		}
		
		if (!in_array($pun_user['g_title'], $Allow_Stats)) {
                   //message($lang_common['No permission']);
            }




$absolute_path_images = dirname(__FILE__) . "/" . substr_replace($idir,"",-1);
$absolute_path_thumbs = dirname(__FILE__) . "/" . substr_replace($tdir,"",-1);

  //find forumurl:
  $domain = $_SERVER['HTTP_HOST']; // find out the domain:
  $path = $_SERVER['SCRIPT_NAME']; // find out the path to the current file:
  $urltemp = "http://" . $domain . $path ; // put it all together:
  $parts = Explode('/', $path);
  $currentFile = end($parts);
  $forumurl = substr($urltemp, 0, strpos($urltemp, "$currentFile"));
  




function prefix( $word, $prefix) {
        if ( strlen($word) < strlen($prefix)) {
                $tmp = $prefix;
                $prefix = $word;
                $word = $tmp;
        }

        $word = substr($word, 0, strlen($prefix));

        if ($prefix == $word) {
                return 1;
        }

        return 0;
}




 	 function strip_ext($name) {
  	     $ext = strrchr($name, '.');
 	     if($ext !== false)
 	     {
	         $name = substr($name, 0, -strlen($ext));
 	     }
 	     return $name;
 	 }
 	 
 	 
function snippet($text,$length=20,$tail="...") {
    $text = trim($text);
    $txtl = strlen($text);
    if($txtl > $length) {
        for($i=1;$text[$length-$i]!=" ";$i++) {
            if($i == $length) {
                return substr($text,0,$length) . $tail;
            }
        }
        $text = substr($text,0,$length-$i+1) . $tail;
    }
    return $text;
}




$Exclude_File = array();
//
// Listed below are two file names that are automatically excluded from the listings.  
// 
$Exclude_File[] = ".htaccess";
$Exclude_File[] = "index.php";
$Exclude_File[] = "index.html";
$Exclude_File[] = "readme.txt";



$Exclude_Folder = array();
//
// Listed below is a folder name that is automatically excluded from the listings.  
//
// $Exclude_Folder[] = "MY_FOLDER";
//
$Exclude_Folder[] = "Restricted";



$Exclude_Extension = array();
//
// Listed below is an extension that automatically excludes ANY file with this extension from the listings.  
//
// $Exclude_Extension[] = "MY_EXTENSION";
//
$Exclude_Extension[] = "hidden";



// set all GET/POST vars
if($_GET) 
{ 
	foreach($_GET as $key => $val) 
	{ 
		$$key = $val;
	}
}
// Get all vars from the POST method.  Assign variable and value
if($_POST) 
{ 
	foreach($_POST as $key => $val) 
	{ 
		$$key = $val;
	}
}

// get file extension
function GetExt($val) {
	
	$val = strtolower($val);
	switch($val) {
	case "gif";
		$type = "GIF";
		$image = "uploadimg_icon.gif";
		break;
	case "jpg";
		$type = "JPEG";
		$image = "uploadimg_icon.gif";
		break;
	case "jpeg";
		$type = "JPEG";
		$image = "uploadimg_icon.gif";
		break;
    case "png";
		$type = "PNG";
		$image = "uploadimg_icon.gif";
		break;
	//--- New Here---//
	default:
		$type = $lang_uploadimg['Unknown filetype'];
		$image = "uploadimg_icon.gif";
	}
	// return both values (to be split)
	return $type."?".$image;
}



// Path to icon folder with ending slash
$iconfolder = $forumurl;

$_GLOBAL['image'] = "";

// Open folder directory
if(!isset($fdir)) {
	$fdir = "./".$idir;
}
$fdir = str_replace("../", "", $fdir);

// check to see if still inside directory boundry
$check = substr($fdir, 0, 2);
if($check != "./") {
	$fdir = "./";
}

// setup file properties class
class File_Properties
{
	var $file_name;		// just the file name
	var $file_ext;		// file extension
	var $file_size;		// size of file
	var $file_dim;		// image dimesions
	var $file_date;		// date modified
	var $file_icon;		// icon for file type
	var $file_type;		// short description for file type

	// constructor method - build object
	function Build($file)
	{
		$this->setFname($file);
		$this->setFext($file);
		$this->setFsize($file);
		$this->setFdim($file);
		$this->setFdate($file);
		$this->setFicon_type();
	}

	// Set file name
	function setFname($file)
	{
		$this->file_name = basename($file);
	}
	// set file extension
	function setFext($file)
	{
		$this->file_ext = array_pop(explode('.', $file));
	}
	// set file size
	function setFsize($file)
	{
		$kbs = filesize($file) / 1024;
		if (($kbs < 1) && ($kbs > 0)) {
		$kbs = 1;
		}
		$this->file_size = $kbs;
	}
	// set image dimensions
	function setFdim($file)
	{
        $fsize = getimagesize($file);
        $fwidth = $fsize[0];
        $fheight = $fsize[1];
        $farea = $fheight*$fwidth;
		$this->file_dim = $farea;
	}
	// set date modified
	function setFdate($file)
	{
		$modified = filemtime($file);
		$this->file_date = $modified;
	}
	// set file type
	function setFicon_type()
	{
		list($this->file_type, $this->file_icon) = explode("\?", GetExt($this->file_ext), 2);
	}

	// setup all get/return methods for class vars
	function getFname()
	{
		return $this->file_name;
	}
	function getFext()
	{
		return $this->file_ext;
	}
	function getFsize()
	{
		return $this->file_size;
	}
	function getFdim()
	{
		return $this->file_dim;
	}
	function getFdate()
	{
		return $this->file_date;
	}
	function getFicon()
	{
		return $this->file_icon;
	}
	function getFtype()
	{
		return $this->file_type;
	}
}



// initialize file and folder arrays
$file_array = array();
$dir_array = array();
$Fname_array = array();
$Dname_array = array();

// open directory
$dir = opendir($fdir);

// Read files into array
while(false !== ($file = readdir($dir))) 
{	

if (empty($getid)) {
$cond = ($file != "." && $file != ".." && filetype($fdir.$file) != "dir");
}
else {
$cond = ($file != "." && $file != ".." && filetype($fdir.$file) != "dir" && prefix($file,$gfile_prefix));
}


	if($cond) 
	{	
		$type = filetype($fdir.$file);
		$info = pathinfo($file);
		if($type != "dir")
		{
			if(isset($info["extension"]))
			{
				$file_extension = $info["extension"];
			}
		}
		
		if($type == "dir" && !in_array($file, $Exclude_Folder)) 
		{
			// setup folder object
			$This_Dir = new Folder_Properties;
			$This_Dir->Build($fdir.$file);
			$dir_array[] = $This_Dir;
		}
		elseif($type == "file" && !in_array($file, $Exclude_File) && !in_array($file_extension, $Exclude_Extension))
		{
			// setup file object
			$This_File = new File_Properties;
			$This_File->Build($fdir.$file);
			$file_array[] = $This_File;
		}
	}
}
closedir($dir);

// Set default sort by method
if(!isset($SortBy) || $SortBy != 0 && $SortBy != 1) {
	$SortBy = 1;
}

// Number of the column to sort by (0-4) set default to 0
if(!isset($NumSort) || $NumSort != 0 && $NumSort != 1 && $NumSort != 2 && $NumSort != 3 && $NumSort != 4) {
	$NumSort = 4;
}

// determin object sorting methods
switch($NumSort) 
{
	case 0;
		$Fsort_method = "file_name";
		$Dsort_method = "dir_name";
	break;
	case 1;
		$Fsort_method = "file_size";
		$Dsort_method = "dir_name";
	break;
	case 2;
		$Fsort_method = "file_type";
		$Dsort_method = "dir_name";
	break;
	case 3;
		$Fsort_method = "file_dim";
		$Dsort_method = "dir_name";
	break;
	case 4;
		$Fsort_method = "file_date";
		$Dsort_method = "dir_date";
	break;
	default:
		$Fsort_method = "file_name";
		$Dsort_method = "dir_name";
}

// object sorting functions
function ASC_sort_file_objects($a, $b) 
{
	global $Fsort_method;
	$obj1 = strtolower($a->$Fsort_method);
	$obj2 = strtolower($b->$Fsort_method);
   	if ($obj1 == $obj2) return 0;
    return ($obj1 < $obj2) ? -1 : 1;
}
function ASC_sort_dir_objects($a, $b) 
{
	global $Dsort_method;
	$obj1 = strtolower($a->$Dsort_method);
	$obj2 = strtolower($b->$Dsort_method);
   	if ($obj1 == $obj2) return 0;
   	return ($obj1 < $obj2) ? -1 : 1;
}
function DESC_sort_file_objects($a, $b) 
{
	global $Fsort_method;
	$obj1 = strtolower($a->$Fsort_method);
	$obj2 = strtolower($b->$Fsort_method);
   	if ($obj1 == $obj2) return 0;
    return ($obj1 > $obj2) ? -1 : 1;
}
function DESC_sort_dir_objects($a, $b) 
{
	global $Dsort_method;
	$obj1 = strtolower($a->$Dsort_method);
	$obj2 = strtolower($b->$Dsort_method);
   	if ($obj1 == $obj2) return 0;
   	return ($obj1 > $obj2) ? -1 : 1;
}

// sort ascending
if($SortBy == 0) {
	// sort arrays (ASCENDING)
	usort($file_array, 'ASC_sort_file_objects');
	usort($dir_array, 'ASC_sort_dir_objects');
	
	$arrow = "&#9650;";
	$SortBy = 1;
	$sortbyopp = 0;
}
// sort descending
else {
	// sort arrays (DESCENDING)
	usort($file_array, 'DESC_sort_file_objects');
	usort($dir_array, 'DESC_sort_dir_objects');
	
	$arrow = "&#9660;";
	$SortBy = 0;
	$sortbyopp = 1;
}





?>
 



<?php 
//------------gallery view start------------


		$rows = $gimages_per_row;
		$row = "0"; ?>
		

		
<div class="block">
	<h2><span>
	<?php 
	if (!empty($getid)){
	echo $lang_uploadimg_gallery['Gallery']."  <a href='uploadimg_gallery.php'>".$lang_uploadimg_gallery['All users']."</a>  ".pun_htmlspecialchars($gdisplayname);
	}
	else {
	echo $lang_uploadimg_gallery['Gallery']."  ".$lang_uploadimg_gallery['All users'];
	}
	?>
	</span></h2>
		<div class="box">
			<div class="inbox">
<center>
<table cellpadding="0">
<tr>

<?php




$num_pages = ceil(count($file_array) / $gimages_per_page);
if (!empty($_GET['p'])){
$p = $_GET['p'];
}
else {
$p = 1;
}


$koos2 = (($p-1)*$gimages_per_page) + $gimages_per_page;

if ($koos2 > count($file_array)){
$koos2 = count($file_array);
}

// output file info
for($y = (($p-1)*$gimages_per_page); $y < $koos2; $y++)
//while (list($key, $val) = each($Fname_array))
{



$filenm = $file_array[$y]->getFname();


//only display thumbnail if it exists:
if(file_exists("$absolute_path_thumbs/$filenm")){

$getcode = "[url=".$forumurl.$idir.$filenm."][img]".$forumurl.$tdir.$filenm."[/img][/url]";
$getimg = "[img]".$forumurl.$idir.$filenm."[/img]";
$geturi = "$forumurl$idir$filenm";
$boxwidth = $twidth - 4;

	    $filename = $file_array[$y]->getFname();
	    $filennn = $filename;
	    
	    $partss = Explode('_', $filename);
	    $preid = $partss[0];
	    $file_prefix = $preid."_";
        $prefix_length = strlen($file_prefix);
        $filename = substr($filename,$prefix_length);
	    
        $filename = strip_ext($filename);
        $filename = str_replace("_", " ", $filename);
        
        $filename = snippet($filename,$snip_filename);
        
        //***
        $result_view = $db->query('SELECT id, username FROM '.$db->prefix.'users WHERE id = '.intval($preid));
        $krydit = $db->fetch_assoc($result_view);
        $displayname = $krydit ['username'];

        if (empty($displayname)){
        $displayname = $lang_uploadimg['Deleted user'];
        }
        
        $displayname = snippet($displayname,$snip_user);
        //***
        
    $isize = getimagesize("$idir$filennn");
    $iwidth = $isize[0];
    $iheight = $isize[1];
        

             if($row == $rows)
            {
            echo"</tr>";

            //display Thumb code only start
			echo "<tr><td valign='bottom' style=\"text-align: center; border: 0px;\">";
            
            
          echo "
          
             <table border='0' cellpadding='0' cellspacing='0' width='100%'>
             <tbody><tr>
              <td style=\"text-align: center; border: 0px;\"><a href=".$idir.$file_array[$y]->getFname()."><img src=\"".$tdir.$file_array[$y]->getFname()."\" /></a>
              </td>
             </tr>
            </tbody></table>
          
 
         	<div class='box'>
	<table cellspacing='0'>
	    <tbody><div style='text-align: center'>
<h2><span>".$filename."</span></h2></div>

			
                <tr>
                    <td class='tcr'>User:</td>
                    <td class='tcr'><a href='uploadimg_gallery.php?id=$preid'>".pun_htmlspecialchars($displayname)."</a></td>
				</tr>
				
                <tr>
                    <td class='tcr'>Uploaded:</td>
                    <td class='tcr'>".format_time($file_array[$y]->getFdate(), true)."</td>
				</tr>
				
                <tr>
                    <td class='tcr'>Filesize:</td>
                    <td class='tcr'>".round($file_array[$y]->getFsize(), 0).$lang_uploadimg['Kilobyte']."</td>
				</tr>
				
                <tr>
                    <td class='tcr'>Dimensions:</td>
                    <td class='tcr'>".$iwidth." x ".$iheight."</td>
				</tr>
				
		</tbody>
		</table>
		</div>

            
            <br /><br /></td>";
			//display Thumb code only end


            $row="1";
            }
        else
        {
            
            //display Thumb code only start
			echo "<td valign='bottom' style=\"text-align: center; border: 0px;\">";
            
          echo "
            
            
              <table border='0' cellpadding='0' cellspacing='0' width='100%'>
             <tbody><tr>
              <td style=\"text-align: center; border: 0px;\"><a href=".$idir.$file_array[$y]->getFname()."><img src=\"".$tdir.$file_array[$y]->getFname()."\" /></a>
              </td>
             </tr>
            </tbody></table>
          
 
         	<div class='box'>
	<table cellspacing='0'>
	    <tbody><div style='text-align: center'>
<h2><span>".$filename."</span></h2></div>

			
                <tr>
                    <td class='tcr'>".$lang_uploadimg_gallery['User'].":</td>
                    <td class='tcr'><a href='uploadimg_gallery.php?id=$preid'>".$displayname."</a></td>
				</tr>
				
                <tr>
                    <td class='tcr'>".$lang_uploadimg_gallery['Uploaded'].":</td>
                    <td class='tcr'>".format_time($file_array[$y]->getFdate(), true)."</td>
				</tr>
				
                <tr>
                    <td class='tcr'>".$lang_uploadimg_gallery['Filesize'].":</td>
                    <td class='tcr'>".round($file_array[$y]->getFsize(), 0).$lang_uploadimg['Kilobyte']."</td>
				</tr>
				
                <tr>
                    <td class='tcr'>".$lang_uploadimg['Dimensions'].":</td>
                    <td class='tcr'>".$iwidth." x ".$iheight."</td>
				</tr>
				
		</tbody>
		</table>
		</div>

            
            <br /><br /></td>"; 
            //display Thumb code only end

            $row++;
        }



	
	}
}
echo "
</tr></table>
</center>
			</div>
		</div>
	</div>";
	
	
	?>
	<div class="linksb">
	<div class="inbox">
	
		<p class="pagelink">
		
		<?php
		
$paging_links = $lang_common['Pages'].': '.paginate($num_pages, $p, 'uploadimg_gallery.php?'.$addthis);
echo $paging_links;
?>

</p>


		
		
		
	</div>
</div>

<?php



//------------gallery view end------------
?>






<?php

require PUN_ROOT.'footer.php';

?>